%define	tcpdump_dir	tcpdump-3.4
Summary: A network traffic monitoring tool.
Name: tcpdump
Version: 3.4
Release: 1.0.4
Copyright: BSD
Group: Networking/Tools

Source0: ftp://ftp.ee.lbl.gov/tcpdump-3.4.tar.gz
Source1: ftp://ftp.ee.lbl.gov/libpcap-0.4.tar.gz
Source2: ftp://ftp.ee.lbl.gov/arpwatch-2.1a4.tar.gz
Source3: arpwatch.init

Patch0: tcpdump-3.4a5-man.patch
Patch1: ftp://ftp.inr.ac.ru/ip-routing/lbl-tools/libpcap-0.4-ss991029.dif.gz
Patch2: ftp://ftp.inr.ac.ru/ip-routing/lbl-tools/tcpdump-3.4-ss991030.dif.gz
Patch3: tcpdump-3.4-glibc21.patch
Patch4: tcpdump-3.4-iphl.patch
Patch5: tcpdump-3.4-getproto.patch
Patch6: arpwatch-2.1a4-typo.patch
Patch7: arpwatch-2.1a4-man.patch
Patch8: arpwatch-2.1a4-fhs.patch

Prefix: %{_prefix}
BuildRoot: /var/tmp/%{name}-root
BuildRequires: kernel-headers >= 2.2.0
Requires: kernel >= 2.2.0
Prereq: /sbin/chkconfig

%description
Tcpdump prints out the headers of packets received or transmitted on a
network interface. An expression can be used to tell tcpdump what kind
of packets should be shown. The primary use of this tool is in analyzing
network performance, or network problems when it is not clear where
something is going wrong.

%package -n libpcap
Version: 0.4
%define	libpcap_dir	libpcap-0.4
Summary: A system-independent interface for user-level packet capture.
Group: Development/Libraries
Requires: kernel >= 2.2.0

%description -n libpcap
Libpcap provides a portable framework for low-level network
monitoring.  Libpcap can provide network statistics collection,
security monitoring and network debugging.  Since almost every system
vendor provides a different interface for packet capture, the libpcap
authors created this system-independent API to ease in porting and to
alleviate the need for several system-dependent packet capture modules
in each application.

Install libpcap if you need to do low-level network traffic monitoring
on your network.

%package -n arpwatch
Version: 2.1a4
%define	arpwatch_dir	arpwatch-2.1a4
Summary: Network monitoring tools for tracking IP addresses on a network.
Group: Applications/System

%description -n arpwatch
The arpwatch package contains arpwatch and arpsnmp.  Arpwatch and
arpsnmp are both network monitoring tools.  Both utilities monitor
Ethernet or FDDI network traffic and build databases of Ethernet/IP
address pairs, and can report certain changes via email.

Install the arpwatch package if you need networking monitoring devices
which will automatically keep track of the IP addresses on your
network.

%prep
%setup -q -c -a 1 -a 2

cd %libpcap_dir
%patch1 -p1
cd ..

cd %tcpdump_dir
%patch0 -p2
%patch2 -p1 -b .tcpdump-ANK
%patch3 -p1 -b .glibc21
%patch4 -p1 -b .iphl
%patch5 -p1 -b .getproto

cd ..

cd %arpwatch_dir
%patch6 -p1 -b .typo
%patch7 -p1 -b .man
%patch8 -p1 -b .fhs
cd ..

%build
cd %libpcap_dir

%configure

DEFS="-fPIC -DHAVE_MALLOC_H=1 -DHAVE_STRERROR=1 -DHAVE_NET_IF_ARP_H=1"
make DEFS="$DEFS"

cd ..

cd %tcpdump_dir

%define	optflags $RPM_OPT_FLAGS -DIP_MAX_MEMBERSHIPS=20
autoconf
%configure
%undefine optflags

DEFS="-DHAVE_FCNTL_H=1 -DHAVE_MALLOC_H=1 -DHAVE_MEMORY_H=1 -DHAVE_RPC_RPCENT_H=1 -DTIME_WITH_SYS_TIME=1 -DHAVE_NET_SLIP_H=1 -DHAVE_VFPRINTF=1 -DHAVE_STRCASECMP=1 -DHAVE_SETLINEBUF=1 -DHAVE_LIBRPC=1 -DRETSIGTYPE=void -DRETSIGVAL= -DHAVE_SIGACTION=1  -DHAVE_FDDI"

make DEFS="$DEFS"
cd ..

cd %arpwatch_dir

%configure
make ARPDIR=/var/arpwatch
cd ..

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/{include/pcap/net,lib,sbin}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/{man3,man8}

cd %libpcap_dir
make DESTDIR=$RPM_BUILD_ROOT INCLDEST=%{_prefix}/include/pcap install install-incl install-man
cd ..

cd %tcpdump_dir
install -m750 -s tcpdump ${RPM_BUILD_ROOT}%{_prefix}/sbin
install -m644 tcpdump.1 ${RPM_BUILD_ROOT}%{_mandir}/man8/tcpdump.8
cd ..

cd %arpwatch_dir
make DESTDIR=$RPM_BUILD_ROOT install install-man
mkdir -p $RPM_BUILD_ROOT/var/arpwatch
for n in arp2ethers massagevendor; do
	install -m750 $n $RPM_BUILD_ROOT/var/arpwatch
done
for n in *.awk *.dat; do
	install -m640 $n $RPM_BUILD_ROOT/var/arpwatch
done
( cd $RPM_BUILD_ROOT
  mkdir -p ./etc/init.d
  install -c -m750 $RPM_SOURCE_DIR/arpwatch.init ./etc/init.d/arpwatch
)
cd ..

( cd $RPM_BUILD_ROOT
  strip .%{_prefix}/sbin/* || :
)

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ -f /etc/init.d/arpwatch ]
then
	/sbin/chkconfig --add arpwatch
fi

%files
%defattr(-,root,root)
%doc	%tcpdump_dir/README %tcpdump_dir/CHANGES
%attr(0750,root,root)	%{_prefix}/sbin/tcpdump
%doc %{_mandir}/man8/tcpdump.8*

%files -n libpcap
%defattr(-,root,root)
%doc	%libpcap_dir/README %libpcap_dir/CHANGES
%{_prefix}/include/pcap
%{_prefix}/lib/libpcap.a
%doc %{_mandir}/man3/pcap.3*

%files -n arpwatch
%defattr(-,root,root)
%doc	%arpwatch_dir/README %arpwatch_dir/CHANGES
%attr(0750,root,admin)	%{_prefix}/sbin/arpwatch
%attr(0750,root,admin)	%{_prefix}/sbin/arpsnmp
%doc %{_mandir}/man8/arpwatch.8*
%doc %{_mandir}/man8/arpsnmp.8*
/etc/init.d/arpwatch
%attr(0750,root,root)	%dir	/var/arpwatch
%attr(0640,root,root)	%config	/var/arpwatch/arp.dat
%attr(0640,root,root)	%config	/var/arpwatch/ethercodes.dat
%attr(0640,root,root)	/var/arpwatch/*.awk
%attr(0640,root,root)	/var/arpwatch/arp2ethers
%attr(0640,root,root)	/var/arpwatch/massagevendor

%changelog
* Thu Oct 19 2000 Pete O'Hara <pete@guardiandigital.com>
- fixed error in arpwatch.init so that it works with chkconfig
	and starts up automatically
- added RH patches
- FHS changes
- several other small changes

* Sat Jul 15 2000 Pete O'Hara <pete@guardiandigital.com>
- removed world access to /var/arpwatch
